diff --git a/roles/bodhi2/backend/templates/pungi.rpm.conf.j2 b/roles/bodhi2/backend/templates/pungi.rpm.conf.j2
index 97afa7c..c8fdc31 100644
--- a/roles/bodhi2/backend/templates/pungi.rpm.conf.j2
+++ b/roles/bodhi2/backend/templates/pungi.rpm.conf.j2
@@ -150,8 +150,8 @@ ostree = {
                     # In the case of testing, also inject the last stable updates
                     "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/updates/f[[ release.version_int ]]-updates/compose/Everything/$basearch/os/",
                 [% endif %]
-                # For F32 the compose location is going to be under /compose/branched/
-                [% if release.version_int == 32 %]
+                # For F33 the compose location is going to be under /compose/branched/
+                [% if release.version_int == 33 %]
                     "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/branched/latest-Fedora-[[ release.version_int ]]/compose/Everything/$basearch/os/"
                 [% else %]
                     "https://kojipkgs{{ env_suffix }}.fedoraproject.org/compose/[[ release.version_int ]]/latest-Fedora-[[ release.version_int ]]/compose/Everything/$basearch/os/"
diff --git a/roles/releng/files/branched b/roles/releng/files/branched
index e3a5bd3..74f08d9 100644
--- a/roles/releng/files/branched
+++ b/roles/releng/files/branched
@@ -1,3 +1,3 @@
 # branched compose
-MAILTO=releng-cron@lists.fedoraproject.org
-15 7 * * * root TMPDIR=`mktemp -d /tmp/branched.XXXXXX` && cd $TMPDIR && git clone https://pagure.io/pungi-fedora.git && cd pungi-fedora && git checkout f32 && /usr/local/bin/lock-wrapper branched-compose "PYTHONMALLOC=debug LANG=en_US.UTF-8 ./nightly.sh" && sudo -u ftpsync /usr/local/bin/update-fullfiletimelist -l /pub/fedora-secondary/update-fullfiletimelist.lock -t /pub fedora fedora-secondary
+#MAILTO=releng-cron@lists.fedoraproject.org
+#15 7 * * * root TMPDIR=`mktemp -d /tmp/branched.XXXXXX` && cd $TMPDIR && git clone https://pagure.io/pungi-fedora.git && cd pungi-fedora && git checkout f32 && /usr/local/bin/lock-wrapper branched-compose "PYTHONMALLOC=debug LANG=en_US.UTF-8 ./nightly.sh" && sudo -u ftpsync /usr/local/bin/update-fullfiletimelist -l /pub/fedora-secondary/update-fullfiletimelist.lock -t /pub fedora fedora-secondary
diff --git a/roles/releng/files/cloud-updates b/roles/releng/files/cloud-updates
index 8c1df3a..0ef075f 100644
--- a/roles/releng/files/cloud-updates
+++ b/roles/releng/files/cloud-updates
@@ -2,9 +2,9 @@
 MAILTO=releng-cron@lists.fedoraproject.org
 15 6 * * * root TMPDIR=`mktemp -d /tmp/CloudF30.XXXXXX` && pushd $TMPDIR && git clone -n https://pagure.io/pungi-fedora.git && cd pungi-fedora && git checkout f30 && LANG=en_US.UTF-8 ./cloud-nightly.sh RC-$(date "+\%Y\%m\%d").0 && popd && rm -rf $TMPDIR
 
-#Fedora 29 Cloud nightly compose
-#MAILTO=releng-cron@lists.fedoraproject.org
-#15 7 * * * root TMPDIR=`mktemp -d /tmp/CloudF29.XXXXXX` && pushd $TMPDIR && git clone -n https://pagure.io/pungi-fedora.git && cd pungi-fedora && git checkout f29 && LANG=en_US.UTF-8 ./cloud-nightly.sh RC-$(date "+\%Y\%m\%d").0 && popd && rm -rf $TMPDIR
+#Fedora 32 Cloud nightly compose
+MAILTO=releng-cron@lists.fedoraproject.org
+15 7 * * * root TMPDIR=`mktemp -d /tmp/CloudF32.XXXXXX` && pushd $TMPDIR && git clone -n https://pagure.io/pungi-fedora.git && cd pungi-fedora && git checkout f32 && LANG=en_US.UTF-8 ./cloud-nightly.sh RC-$(date "+\%Y\%m\%d").0 && popd && rm -rf $TMPDIR
 
 #Fedora 31 Cloud nightly compose
 MAILTO=releng-cron@lists.fedoraproject.org
diff --git a/roles/releng/files/container-updates b/roles/releng/files/container-updates
index 769b78f..ac0dc25 100644
--- a/roles/releng/files/container-updates
+++ b/roles/releng/files/container-updates
@@ -6,6 +6,6 @@ MAILTO=releng-cron@lists.fedoraproject.org
 MAILTO=releng-cron@lists.fedoraproject.org
 45 7 * * * root TMPDIR=`mktemp -d /tmp/containerF30.XXXXXX` && pushd $TMPDIR && git clone -n https://pagure.io/pungi-fedora.git && cd pungi-fedora && git checkout f30 && LANG=en_US.UTF-8 ./container-nightly.sh RC-$(date "+\%Y\%m\%d").0 && popd && rm -rf $TMPDIR
 
-# Fedora 29 Container Updates nightly compose
-#MAILTO=releng-cron@lists.fedoraproject.org
-#45 6 * * * root TMPDIR=`mktemp -d /tmp/containerF29.XXXXXX` && pushd $TMPDIR && git clone -n https://pagure.io/pungi-fedora.git && cd pungi-fedora && git checkout f29 && LANG=en_US.UTF-8 ./container-nightly.sh RC-$(date "+\%Y\%m\%d").0 && popd && rm -rf $TMPDIR
+# Fedora 32 Container Updates nightly compose
+MAILTO=releng-cron@lists.fedoraproject.org
+45 6 * * * root TMPDIR=`mktemp -d /tmp/containerF32.XXXXXX` && pushd $TMPDIR && git clone -n https://pagure.io/pungi-fedora.git && cd pungi-fedora && git checkout f32 && LANG=en_US.UTF-8 ./container-nightly.sh RC-$(date "+\%Y\%m\%d").0 && popd && rm -rf $TMPDIR
diff --git a/vars/all/00-FedoraCycleNumber.yaml b/vars/all/00-FedoraCycleNumber.yaml
index 4bd0d46..acabe9c 100644
--- a/vars/all/00-FedoraCycleNumber.yaml
+++ b/vars/all/00-FedoraCycleNumber.yaml
@@ -1 +1 @@
-FedoraCycleNumber: 31
+FedoraCycleNumber: 32
diff --git a/vars/all/FedoraBranched.yaml b/vars/all/FedoraBranched.yaml
index 42ac534..0bbcc1d 100644
--- a/vars/all/FedoraBranched.yaml
+++ b/vars/all/FedoraBranched.yaml
@@ -1 +1 @@
-FedoraBranched: True 
+FedoraBranched: False 
diff --git a/vars/all/FedoraBranchedBodhi.yaml b/vars/all/FedoraBranchedBodhi.yaml
index 380f61d..76ba14d 100644
--- a/vars/all/FedoraBranchedBodhi.yaml
+++ b/vars/all/FedoraBranchedBodhi.yaml
@@ -1,2 +1,2 @@
 #options are: prebeta, postbeta, current
-FedoraBranchedBodhi: postbeta 
+FedoraBranchedBodhi: current 
diff --git a/vars/all/RelEngFrozen.yaml b/vars/all/RelEngFrozen.yaml
index bd7553f..5836689 100644
--- a/vars/all/RelEngFrozen.yaml
+++ b/vars/all/RelEngFrozen.yaml
@@ -1 +1 @@
-RelEngFrozen: True 
+RelEngFrozen: False