diff -Naur livecd.3.squashed_image_to_LiveOS/creator/isotostick.sh livecd.4.syslinux_to_boot/creator/isotostick.sh
--- livecd.3.squashed_image_to_LiveOS/creator/isotostick.sh	2007-09-21 07:08:32.000000000 +0000
+++ livecd.4.syslinux_to_boot/creator/isotostick.sh	2007-09-21 07:28:18.000000000 +0000
@@ -132,7 +132,7 @@
     if ! syslinux 2>&1 | grep -qe -d; then
 	SYSLINUXPATH=""
     else
-	SYSLINUXPATH="syslinux"
+	SYSLINUXPATH="boot/syslinux"
     fi
 }
 
@@ -201,7 +201,7 @@
 fi
 
 echo "Copying live image to USB stick"
-if [ ! -d $USBMNT/$SYSLINUXPATH ]; then mkdir $USBMNT/$SYSLINUXPATH ; fi
+if [ ! -d $USBMNT/$SYSLINUXPATH ]; then mkdir -p $USBMNT/$SYSLINUXPATH ; fi
 if [ ! -d $USBMNT/LiveOS ]; then mkdir $USBMNT/LiveOS ; fi
 # cases without /LiveOS are legacy detection, remove for F10
 if [ -f $CDMNT/LiveOS/squashfs.img ]; then
@@ -219,7 +219,13 @@
     cp $CDMNT/osmin.gz $USBMNT/LiveOS/osmin.gz || exitclean
 fi
 
-cp $CDMNT/isolinux/* $USBMNT/$SYSLINUXPATH
+# case without /boot is legacy detection, remove for F10
+if [ -d $CDMNT/boot/isolinux ]; then
+    cp $CDMNT/boot/isolinux/* $USBMNT/$SYSLINUXPATH
+else
+    cp $CDMNT/isolinux/* $USBMNT/$SYSLINUXPATH
+fi
+
 
 echo "Updating boot config file"
 # adjust label and fstype
@@ -240,7 +246,7 @@
     # extlinux expects the config to be named extlinux.conf
     # and has to be run with the file system mounted
     mv $USBMNT/$SYSLINUXPATH/isolinux.cfg $USBMNT/$SYSLINUXPATH/extlinux.conf
-    extlinux -i $USBMNT/syslinux
+    extlinux -i $USBMNT/$SYSLINUXPATH
     cleanup
 fi
 
diff -Naur livecd.3.squashed_image_to_LiveOS/creator/livecd-creator livecd.4.syslinux_to_boot/creator/livecd-creator
--- livecd.3.squashed_image_to_LiveOS/creator/livecd-creator	2007-09-21 07:47:23.000000000 +0000
+++ livecd.4.syslinux_to_boot/creator/livecd-creator	2007-09-21 07:47:45.000000000 +0000
@@ -1088,15 +1088,16 @@
     """ImageCreator for x86 machines"""
     def configureBootloader(self):
         """configure the boot loader"""
-        os.makedirs(self.build_dir + "/out/isolinux")
+        os.makedirs(self.build_dir + "/out/boot")
+        os.makedirs(self.build_dir + "/out/boot/isolinux")
 
         shutil.copyfile("%s/install_root/boot/vmlinuz-%s"
                         %(self.build_dir, self.get_kernel_version()),
-                        "%s/out/isolinux/vmlinuz" %(self.build_dir,))
+                        "%s/out/boot/isolinux/vmlinuz" %(self.build_dir,))
 
         shutil.copyfile("%s/install_root/boot/livecd-initramfs.img"
                         %(self.build_dir,),
-                        "%s/out/isolinux/initrd.img" %(self.build_dir,))
+                        "%s/out/boot/isolinux/initrd.img" %(self.build_dir,))
         os.unlink("%s/install_root/boot/livecd-initramfs.img"
                   %(self.build_dir,))
 
@@ -1116,7 +1117,7 @@
         isXen = False
         xen = glob.glob("%s/install_root/boot/xen.gz-*" %(self.build_dir,))
         if len(xen) > 0:
-            shutil.copyfile(xen[0], "%s/out/isolinux/xen.gz" %(self.build_dir,))
+            shutil.copyfile(xen[0], "%s/out/boot/isolinux/xen.gz" %(self.build_dir,))
             syslinuxfiles.append("mboot.c32")
             isXen = True
 
@@ -1125,11 +1126,11 @@
             if not os.path.isfile(path):
                 raise InstallationError("syslinux not installed : %s not found" % path)
 
-            shutil.copy(path, "%s/out/isolinux/%s" % (self.build_dir, p))
+            shutil.copy(path, "%s/out/boot/isolinux/%s" % (self.build_dir, p))
 
         if os.path.exists("%s/install_root/usr/lib/anaconda-runtime/syslinux-vesa-splash.jpg" %(self.build_dir,)):
             shutil.copy("%s/install_root/usr/lib/anaconda-runtime/syslinux-vesa-splash.jpg" %(self.build_dir,),
-                        "%s/out/isolinux/splash.jpg" %(self.build_dir,))
+                        "%s/out/boot/isolinux/splash.jpg" %(self.build_dir,))
             have_background = "menu background splash.jpg"
         else:
             have_background = ""
@@ -1179,7 +1180,7 @@
 
         memtest = glob.glob("%s/install_root/boot/memtest86*" %(self.build_dir,))
         if len(memtest) > 0:
-            shutil.copy(memtest[0], "%s/out/isolinux/memtest" %(self.build_dir,))
+            shutil.copy(memtest[0], "%s/out/boot/isolinux/memtest" %(self.build_dir,))
             cfg += """label memtest
   menu label Memory Test
   kernel memtest
@@ -1190,7 +1191,7 @@
   menu label Boot from local drive
   localboot 0xffff"""
 
-        cfgf = open("%s/out/isolinux/isolinux.cfg" %(self.build_dir,), "w")
+        cfgf = open("%s/out/boot/isolinux/isolinux.cfg" %(self.build_dir,), "w")
         cfgf.write(cfg)
         cfgf.close()
         
@@ -1199,8 +1200,8 @@
     def createIso(self):
         """Write out the live CD ISO."""
         rc = subprocess.call(["/usr/bin/mkisofs", "-o", "%s.iso" %(self.fs_label,),
-                         "-b", "isolinux/isolinux.bin",
-                         "-c", "isolinux/boot.cat",
+                         "-b", "boot/isolinux/isolinux.bin",
+                         "-c", "boot/isolinux/boot.cat",
                          "-no-emul-boot", "-boot-load-size", "4",
                          "-boot-info-table",
                          "-J", "-r", "-hide-rr-moved", "-hide-joliet-trans-tbl",